' NOTE: These functions use DynaCall to access the WIN32 API

const HWND_BROADCAST = -1
const SC_SCREENSAVE = 61760 ' &HF140&
const WM_SYSCOMMAND = 274 ' &H112
const WM_CLOSE = 16 ' &H10& 
const SPI_GETSCREENSAVERRUNNING = 114 ' &H72
const SC_MONITORPOWER = 61808 ' &F170&

' Set monitor to ON, STANDBY, or OFF
sub SetMonitorState(iState)
    ' ON = -1, STANDBY = 1, OFF = 2
    Set oItem = CreateObject("DynamicWrapper")
    oItem.Register "USER32.DLL", "SendMessageA", "I=llll", "f=s", "R=l"
    oItem.SendMessageA HWND_BROADCAST, WM_SYSCOMMAND, SC_MONITORPOWER, iState
end sub

' Activate or deactivate the screensaver
' Deactivation will not work if screensaver uses a password
sub ScreenSaver(bScreenSaver)
    ' Based on work by Ronald Saikali  http://vbcity.com/forums/topic.asp?tid=10020
    dim lHnd: lHnd = 0
    dim sActive: sActive = ""
    set oSend = CreateObject("DynamicWrapper")
    oSend.Register "USER32.DLL", "SendMessageA", "I=llll", "f=s", "R=l"

    if bScreenSaver then  ' Activate the screen saver 
        oSend.SendMessageA HWND_BROADCAST, WM_SYSCOMMAND, SC_SCREENSAVE, 0 
    else ' Determine if screensaver is currently active
        set oSystem = CreateObject("DynamicWrapper")
        oSystem.Register "USER32.DLL", "SystemParametersInfoA", "I=llrl", "f=s", "R=l"
        lHnd = oSystem.SystemParametersInfoA(SPI_GETSCREENSAVERRUNNING, 0, sActive, 0) ' Must assign return value to a variable otherwise the call fails
        ' KLUDGE ALERT
        ' SystemParametersInfoA updates the state of the sActive variable.
        ' Ideally, sActive should be of type Boolean.
        ' Unfortunately, String is the only data-type that DynamicWrapper supports as pass-by-reference.
        ' sActive is initialized as an empty string to represent False.  If it returns non-empty than it is considered to be True.

        if sActive <> "" then ' Close the foreground application
            set oFore = CreateObject("DynamicWrapper")
            ' KLUDGE ALERT
            ' GetForegroundWindow does not take any parameters yet DynamicWrapper insists on at least one input parameter.
            ' So one Long parameter is defined just to make it happy.
            oFore.Register "USER32.DLL", "GetForegroundWindow", "I=l", "f=s", "R=l"
            lHnd = oFore.GetForegroundWindow(0)
            oSend.SendMessageA lHnd, WM_CLOSE, 0, 0 
            set oFore = nothing
        end if 
        set oSystem = nothing
    end if 
    set oSend = nothing
end sub